diff -urN linux.store/linux/arch/arm/kernel/ecard.c linux/arch/arm/kernel/ecard.c
--- linux.store/linux/arch/arm/kernel/ecard.c	Tue Mar  5 13:04:29 1996
+++ linux/arch/arm/kernel/ecard.c	Wed Mar 13 14:47:54 1996
@@ -20,12 +20,16 @@
 #include <asm/ecard.h>
 #include <asm/irq.h>
 #include <asm/io.h>
+#ifdef CONFIG_ARCH_ARC
+#include <asm/arch/oldlatches.h>
+#endif
 
 /*
  * from linux/arch/arm/kernel/irq.c
  */
 extern void do_fast_IRQ(int irq);
 extern unsigned char *ioc;
+int ecard_num_cards;
 
 #define MAX_ECARDS 4
 
@@ -36,7 +40,7 @@
 static char initialised = 0;
 static unsigned long kmem;
 
-void *ecard_malloc(int len)
+static void *ecard_malloc(int len)
 {
     int r;
 
@@ -53,8 +57,9 @@
 static void expansioncard_irq_noexpmask(int intr_no, struct pt_regs *regs)
 {
     int i;
+    const int num_cards = ecard_num_cards;
 
-    for(i=0; i<MAX_ECARDS; i++) {
+    for (i = 0; i < num_cards; i++) {
 	if (expcard[i].r_found && expcard[i].r_claimed && expcard[i].irq) {
 	    if (expcard[i].r_irqmask) {
 		if(expcard[i].r_irqaddr[0] & expcard[i].r_irqmask)
@@ -70,11 +75,12 @@
 static void expansioncard_irq_expmask (int intr_no, struct pt_regs *regs)
 {
     int i, ns = 0;
+    const int num_cards = ecard_num_cards;
 #if 0
     int oldexpmask;
 #endif
 
-    for (i = 0; i < MAX_ECARDS; i++) {
+    for (i = 0; i < num_cards; i++) {
 	if (expmask[0] & (1 << i)) {
 	    if (expcard[i].r_found && expcard[i].r_claimed) {
 		if (!expcard[i].r_irqmask || (expcard[i].r_irqaddr[0] & expcard[i].r_irqmask)) {
@@ -136,51 +142,73 @@
     }*/
 }
 
-static int ecard_checkirqhw(void)
+static int ecard_checkirqhw (void)
 {
-	int found;
-	expmask[4] = 0x00;
-	expmask[0] = 0xff;
-	found = (expmask[0] == 0xf0);
-	expmask[4] = 0xff;
-	return found;
+    int found;
+    expmask[4] = 0x00;
+    expmask[0] = 0xff;
+    found = (expmask[0] == 0xf0);
+    expmask[4] = 0xff;
+    return found;
 }
 
-static void ecard_readbytes(void *addr, struct expansion_card *ec, int off, int len, int useld)
+static void ecard_readbytes (void *addr, struct expansion_card *ec, int off, int len, int useld)
 {
-	extern int read_loader(int off, volatile unsigned char *pa, unsigned char *loader);
+    extern int ecard_loader_read(int off, volatile unsigned char *pa, unsigned char *loader);
   
-	unsigned char *a = (unsigned char *)addr;
+    unsigned char *a = (unsigned char *)addr;
 
-	if(!useld || !ec->r_loader) {
-		while(len--)
-			*a++ = ec->r_podaddr[(off++)*4];
-	} else {
-		while(len--) {
-			*(unsigned long *)0x108 = 0; /* hack for some loaders!!! */
-			*a++ = read_loader(off++, ec->r_podaddr, ec->r_loader);
-		}
+    if (!useld || !ec->r_loader) {
+	while(len--)
+	    *a++ = ec->r_podaddr[(off++)*4];
+    } else {
+	while(len--) {
+	    *(unsigned long *)0x108 = 0; /* hack for some loaders!!! */
+	    *a++ = ecard_loader_read(off++, ec->r_podaddr, ec->r_loader);
 	}
+    }
 }
 
-struct expansion_card *ecard_find(int cld, int num, int prod[], int manu[])
+/*
+ * This is called to reset the loaders for each expansion card on reboot.
+ *
+ * This is required to make sure that the card is in the correct state
+ * that RiscOS expects it to be.
+ */
+void ecard_reset (int card)
 {
-	int i, j;
+    extern int ecard_loader_reset (volatile unsigned char *pa, unsigned char *loader);
 
-	for (i = 0 ; i<MAX_ECARDS; i++) {
-		if(expcard[i].r_found == 0 || expcard[i].r_claimed)
-			continue;
-		if((e_ecld(&expcard[i].ecld) & 0x78) != (cld & 0x78))
-			continue;
-		if((e_ecld(&expcard[i].ecld) & 0x78) != 0)
-			return &expcard[i];
-		for (j = 0; j<num; j++) {
-			if(e_prod(&expcard[i].ecld) == prod[j] &&
-				e_manu(&expcard[i].ecld) == manu[j])
-				return &expcard[i];
-		}
+    if (card >= ecard_num_cards)
+	return;
+    
+    if (card < 0) {
+	for (card = 0; card < ecard_num_cards; card++)
+	    if (expcard[card].r_loader)
+		ecard_loader_reset (expcard[card].r_podaddr, expcard[card].r_loader);
+    } else
+	if (expcard[card].r_loader)
+	    ecard_loader_reset (expcard[card].r_podaddr, expcard[card].r_loader);
+}
+
+struct expansion_card *ecard_find (int cld, int num, int prod[], int manu[])
+{
+    int i, j;
+
+    for (i = 0 ; i < ecard_num_cards; i++) {
+	if(expcard[i].r_found == 0 || expcard[i].r_claimed)
+	    continue;
+	if((e_ecld(&expcard[i].ecld) & 0x78) != (cld & 0x78))
+	    continue;
+	if((e_ecld(&expcard[i].ecld) & 0x78) != 0)
+	    return &expcard[i];
+	for (j = 0; j<num; j++) {
+	    if (e_prod(&expcard[i].ecld) == prod[j] &&
+		e_manu(&expcard[i].ecld) == manu[j])
+		    return &expcard[i];
 	}
-	return NULL;
+    }
+    return NULL;
 }
 
 int ecard_readchunk(struct chunk_dir *cd, struct expansion_card *ec, int id, int num)
@@ -230,28 +258,37 @@
 unsigned long ecard_init(unsigned long my_kmem)
 {
     int i;
+
     kmem = (my_kmem | 3) + 1;
+
     initialised = 0;
+    ecard_num_cards = 4;
 
-    for (i=0; i<MAX_ECARDS; i++) {
+    if (ecard_num_cards > MAX_ECARDS)
+	ecard_num_cards = MAX_ECARDS;
+
+    for (i = 0; i < ecard_num_cards; i++) {
 	expcard[i].r_claimed = 0;
 	expcard[i].r_found = 0;
     }
 
+    if (ecard_num_cards == 0)
+	return kmem;
+
     if (ecard_checkirqhw()) {
 	have_expmask = 0xff;
 	printk("Expansion card interrupt management hardware found\n");
     }
 
-    if (request_irq(IRQ_EXPANSIONCARD, have_expmask ? expansioncard_irq_expmask :
+    if (request_irq (IRQ_EXPANSIONCARD, have_expmask ? expansioncard_irq_expmask :
 		expansioncard_irq_noexpmask, 0, "expansion cards") != 0) {
-	printk("Could not allocate interrupt for expansion cards\n");
+	printk ("Could not allocate interrupt for expansion cards\n");
 	return kmem;
     }
 	
     printk("Searching for expansion cards:");
 
-    for (i=0; i<MAX_ECARDS; i++) {
+    for (i = 0; i < ecard_num_cards; i++) {
 	struct expansion_card *ec;
 		
 	ec = &expcard[i];
@@ -262,7 +299,7 @@
 	ec->irq = 0;
 	ec->fiq = 0;
 		
-	ecard_readbytes(&ec->ecld, ec, 0, 16, 0);
+	ecard_readbytes (&ec->ecld, ec, 0, 16, 0);
 		
 	if (ec->ecld.r_ecld & 2) {
 	    have_expmask &= ~(1<<i);
@@ -306,5 +343,11 @@
 
 unsigned long bios32_init(unsigned long start_mem, unsigned long end_mem)
 {
-    return ecard_init(start_mem);
+    unsigned long mem;
+
+    mem = ecard_init(start_mem);
+
+#ifdef CONFIG_ARCH_ARC
+    oldlatch_init ();
+#endif
 }
diff -urN linux.store/linux/arch/arm/kernel/head.S linux/arch/arm/kernel/head.S
--- linux.store/linux/arch/arm/kernel/head.S	Sun Mar  3 13:03:43 1996
+++ linux/arch/arm/kernel/head.S	Thu Mar 14 23:26:08 1996
@@ -67,39 +67,32 @@
 @		4156025X = ARM 250
 @		4156020X = ARM 2
 @
-		adr	r0, undef_instr - 12
-		mov	r2, #4
-		mov	r3, #0xea000000
-		orr	r0, r3, r0, lsr #2
-		str	r0, [r2]
-
-		mrc	15, 0, r0, c0, c0
-
-continue:
+		adr	r3, undef_instr - 12
+		mov	r2, #0
+		mov	r0, #0xea000000
+		orr	r3, r0, r3, lsr #2
+		str	r3, [r2, #4]
+
+		ldr	r3, arm2_id
+		swp	r0, r0, [r2]		@ check for swp - if it can't do it, then it
+		ldr	r3, arm250_id		@ must be ARM2
+		mrc	15, 0, r0, c0, c0	@ check for CP#15 - if it can't do it, then ARM250
+		mov	r3, r0
+continue:	ldr	r0, [pc, #LC4 - . - 8]
+		str	r3, [r0]
 @
 @ Make undefined instr vector point to itself (endless loop)
 @
+		mov	r3, #0xeb000000
 		sub	r3, r3, #2
-		orr	r3, r3, #0xeb000000
-		str	r3, [r2]
-		ldr	r3, [pc, #LC4 - . - 8]
-		str	r0, [r3]
+		mov	r2, #0
+		str	r3, [r2, #4]
 		mov	fp, #0
 		b	_start_kernel
 @
-@ IF we come in here from the mrc instruction, then we have an ARM2/250
+@ IF we come in here then one of the swp / mrc instructions must have aborted - jum
 @
-undef_instr:	adr	r0, undef_instr2 - 12
-		orr	r0, r3, r0, lsr #2
-		str	r0, [r2], #4
-		swpb	r0, r0, [r2]
-		ldr 	r0, arm250_id
-		b	continue
-
-arm250_id:	.long	0x41560250
-
-undef_instr2:	ldr	r0, arm2_id
-		b	continue
+undef_instr:	b	continue
 
 arm2_id:	.long	0x41560200
-
+arm250_id:	.long	0x41560250
diff -urN linux.store/linux/arch/arm/kernel/irq.c linux/arch/arm/kernel/irq.c
--- linux.store/linux/arch/arm/kernel/irq.c	Sun Mar  3 13:04:56 1996
+++ linux/arch/arm/kernel/irq.c	Wed Mar 13 15:12:17 1996
@@ -51,8 +51,12 @@
     extern void ecard_disableirq (unsigned int);
     unsigned long flags;
 
+#ifdef cliIF
     save_flags(flags);
-    cli();
+    cliIF();
+#else
+    save_flags_cli (flags);
+#endif
 
     enabled_irqs &= ~(1 << irq_nr);
 
@@ -75,8 +79,12 @@
     extern void ecard_enableirq (unsigned int);
     unsigned long flags;
 
-    save_flags(flags);
-    cli();
+#ifdef cliIF
+    save_flags (flags);
+    cliIF();
+#else
+    save_flags_cli (flags);
+#endif
 
     enabled_irqs |= 1 << irq_nr;
 
diff -urN linux.store/linux/arch/arm/kernel/oldlatches.c linux/arch/arm/kernel/oldlatches.c
--- linux.store/linux/arch/arm/kernel/oldlatches.c	Thu Jan  1 01:00:00 1970
+++ linux/arch/arm/kernel/oldlatches.c	Mon Mar 11 23:27:12 1996
@@ -0,0 +1,47 @@
+/* Support for the latches on the old Archimedes which control the floppy,
+   hard disc and printer
+
+   (c) David Alan Gilbert 1995/1996
+
+*/
+#include <linux/config.h>
+#include <linux/kernel.h>
+
+#include <asm/machdep.h>
+#include <asm/io.h>
+
+/* They are static so that everyone who accesses them has to go through here */
+static unsigned char LatchACopy;
+static unsigned char LatchBCopy;
+
+#define LATCHAADDR 0x3250040
+#define LATCHBADDR 0x3250018
+
+/* newval=(oldval & ~mask)|newdata */
+void oldlatch_aupdate(unsigned char mask,unsigned char newdata)
+{
+  LatchACopy=(LatchACopy & ~mask)|newdata;
+  outb(LatchACopy,(LATCHAADDR >> 2));
+#ifdef DEBUG
+  printk("oldlatch_A:0x%2x\n",LatchACopy);
+#endif
+
+};
+
+/* newval=(oldval & ~mask)|newdata */
+void oldlatch_bupdate(unsigned char mask,unsigned char newdata)
+{
+  LatchBCopy=(LatchBCopy & ~mask)|newdata;
+  outb(LatchBCopy,(LATCHBADDR >> 2));
+#ifdef DEBUG
+  printk("oldlatch_B:0x%2x\n",LatchBCopy);
+#endif
+};
+
+void oldlatch_init(void)
+{
+  printk("oldlatch: init\n");
+  oldlatch_aupdate(0xff,0xff);
+  oldlatch_bupdate(0xff,0x8); /* Thats no FDC reset...*/
+  return ;
+}
diff -urN linux.store/linux/arch/arm/kernel/process.c linux/arch/arm/kernel/process.c
--- linux.store/linux/arch/arm/kernel/process.c	Tue Mar  5 13:04:29 1996
+++ linux/arch/arm/kernel/process.c	Fri Mar  8 22:36:31 1996
@@ -60,12 +60,17 @@
 
 void hard_reset_now(void)
 {
+    extern void ecard_reset (int card);
+    extern unsigned long arm_id;
+    /*
+     * reset all expansion cards
+     */
+    ecard_reset (-1);
     /*
      * If we are using the ARM3, turn off the cache!
      * otherwise we get problems with 256 colour modes
      * and floppy drive accesses in RiscOS.
      */
-    extern unsigned long arm_id;
     if ((arm_id & 0xfffffff0) == 0x41560300)
 	__asm__ __volatile__ ("mcr 15, 0, %0, c2, c0": : "r" (2));
 
diff -urN linux.store/linux/arch/arm/kernel/setup.c linux/arch/arm/kernel/setup.c
--- linux.store/linux/arch/arm/kernel/setup.c	Thu Mar 14 23:33:06 1996
+++ linux/arch/arm/kernel/setup.c	Thu Mar 14 23:09:24 1996
@@ -30,6 +30,7 @@
 #define F_MEMC   (1<<0)
 #define F_MMU    (1<<1)
 #define F_32BIT  (1<<2)
+#define F_CACHE  (1<<3)
 #define F_IOEB   (1<<31)
 
 struct drive_info_struct { char dummy[32]; } drive_info;
@@ -74,7 +75,7 @@
 } armidlist[] = {
 	{ 0x41560200, 0xfffffff0, F_MEMC	, 0x03000000	, "ARM",	"arm2"		},
 	{ 0x41560250, 0xfffffff0, F_MEMC	, 0x03000000	, "ARM",	"arm250"	},
-	{ 0x41560300, 0xfffffff0, F_MEMC	, 0x03000000	, "ARM",	"arm3"		},
+	{ 0x41560300, 0xfffffff0, F_MEMC|F_CACHE, 0x03000000	, "ARM",	"arm3"		},
 	{ 0x41560610, 0xfffffff0, F_MMU|F_32BIT	, 0		, "ARM",	"arm610"	},
 	{ 0x44450000, 0xffff0000, F_MMU		, 0		, "DEC",	"SA-1"		},
 	{ 0x00000000, 0x00000000, 0		, 0		, "***",	"*unknown*"	}
@@ -96,7 +97,9 @@
 extern int bytes_per_char_h;
 extern int bytes_per_char_v;
 extern char arc_hd_files[8][128];
+#ifdef CONFIG_BLK_DEV_HD
 extern int no_hds;
+#endif
 extern int ramdisk_size;
 extern int root_mountflags;
 extern int _etext, _edata, _end;
@@ -140,7 +143,7 @@
 
 	check_ioeb_present();
 
-	if ((arm_id & 0x0000fff0) == 0x300) {
+	if (armidlist[armidindex].features & F_CACHE) {
 		__asm__ __volatile__("
 		mcr	15, 0, %0, c3, c0
 		mcr	15, 0, %1, c4, c0
@@ -150,7 +153,7 @@
 		" : : "r" (0x000e7fff), "r" (0x000e7fff), "r" (0xf0000000), "r" (3));
 	} else {
 		/* ok, so this is a bit dirty... Self modifing code! */
-		extern unsigned long *arm3_flushcache;
+		extern unsigned long arm3_flushcache[2];
 		arm3_flushcache[0] = arm3_flushcache[1];
 	}
 
@@ -165,8 +168,9 @@
 	ORIG_VIDEO_COLS = params->video_num_cols;
 	ORIG_VIDEO_LINES = params->video_num_rows;
 	memc_ctrl_reg = params->memc_control_reg;
+#ifdef CONFIG_BLK_DEV_HD
 	no_hds = (params->adfsdrives >> 6) & 3;
-
+#endif
 	aux_device_present = 0;
 	memory_end = 0x02000000 + params->page_size * params->nr_pages;
 	ramdisk_size = params->ramdisk_size;
diff -urN linux.store/linux/arch/arm/kernel/sys-arm.c linux/arch/arm/kernel/sys-arm.c
--- linux.store/linux/arch/arm/kernel/sys-arm.c	Tue Mar  5 13:04:29 1996
+++ linux/arch/arm/kernel/sys-arm.c	Wed Mar 13 22:19:33 1996
@@ -10,6 +10,7 @@
  */
 
 #include <linux/config.h>
+#include <linux/module.h>
 #include <linux/errno.h>
 #include <linux/sched.h>
 #include <linux/mm.h>
@@ -182,7 +183,7 @@
 asmlinkage int
 sys_arm_init_module (char *module_name, char *code, unsigned codesize, unsigned long *__p)
 {
-    extern int sys_init_module (char *, char *, unsigned, struct mod_routes *,
+    extern int sys_init_module (char *, char *, unsigned, struct mod_routines *,
     		struct symbol_table *);
     return sys_init_module (module_name, code, codesize, (struct mod_routines *)__p[0],
     		(struct symbol_table *)__p[1]);
diff -urN linux.store/linux/arch/arm/kernel/time.c linux/arch/arm/kernel/time.c
--- linux.store/linux/arch/arm/kernel/time.c	Sun Mar  3 13:07:50 1996
+++ linux/arch/arm/kernel/time.c	Wed Mar 13 12:27:14 1996
@@ -31,47 +31,46 @@
 
 unsigned long do_dummy_gettimeoffset(void)
 {
-	return 0;
+    return 0;
 }
 
 static unsigned long (*do_gettimeoffset)(void) = do_dummy_gettimeoffset;
 
 void do_gettimeofday(struct timeval *tv)
 {
-	unsigned long flags;
+    unsigned long flags;
 
-	save_flags (flags);
-	cli();
-	*tv = xtime;
-	tv->tv_usec += do_gettimeoffset();
-	if (tv->tv_usec >= 1000000) {
-		tv->tv_usec -= 1000000;
-		tv->tv_sec++;
-	}
-	restore_flags(flags);
+    save_flags_cli (flags);
+    *tv = xtime;
+    tv->tv_usec += do_gettimeoffset();
+    if (tv->tv_usec >= 1000000) {
+	tv->tv_usec -= 1000000;
+	tv->tv_sec++;
+    }
+    restore_flags(flags);
 }
 
 void do_settimeofday(struct timeval *tv)
 {
-	cli();
-	/* This is revolting. We need to set the xtime.tv_usec
-	 * correctly. However, the value in this location is
-	 * is value at the last tick.
-	 * Discover what correction gettimeofday
-	 * would have done, and then undo it!
-	 */
-	tv->tv_usec -= do_gettimeoffset();
-
-	if (tv->tv_usec < 0) {
-		tv->tv_usec += 1000000;
-		tv->tv_sec--;
-	}
-
-	xtime = *tv;
-	time_state = TIME_BAD;
-	time_maxerror = 0x70000000;
-	time_esterror = 0x70000000;
-	sti();
+    cli ();
+    /* This is revolting. We need to set the xtime.tv_usec
+     * correctly. However, the value in this location is
+     * is value at the last tick.
+     * Discover what correction gettimeofday
+     * would have done, and then undo it!
+     */
+    tv->tv_usec -= do_gettimeoffset();
+
+    if (tv->tv_usec < 0) {
+	tv->tv_usec += 1000000;
+	tv->tv_sec--;
+    }
+
+    xtime = *tv;
+    time_state = TIME_BAD;
+    time_maxerror = 0x70000000;
+    time_esterror = 0x70000000;
+    sti ();
 }
 
 /*
@@ -83,8 +82,8 @@
  */
 int set_rtc_mmss(unsigned long nowtime)
 {
-  int retval = 0;
-  return retval;
+    int retval = 0;
+    return retval;
 }
 
 /* last time the cmos clock got updated */
@@ -96,19 +95,20 @@
  */
 static inline void timer_interrupt(int irq, struct pt_regs *regs)
 {
-	do_timer(regs);
+    do_timer(regs);
 
-	/* If we have an externally synchronized linux clock, then update
-	 * CMOS clock accordingly every ~11 minutes.  Set_rtc_mmss() has to be
-	 * called as close as possible to 500 ms before the new second starts.
-	 */
-	if (time_state != TIME_BAD && xtime.tv_sec > last_rtc_update + 660 &&
+    /* If we have an externally synchronized linux clock, then update
+     * CMOS clock accordingly every ~11 minutes.  Set_rtc_mmss() has to be
+     * called as close as possible to 500 ms before the new second starts.
+     */
+    if (time_state != TIME_BAD && xtime.tv_sec > last_rtc_update + 660 &&
 	    xtime.tv_usec > 50000 - (tick >> 1) &&
-	    xtime.tv_usec < 50000 + (tick >> 1))
-	  if (set_rtc_mmss(xtime.tv_sec) == 0)
+	    xtime.tv_usec < 50000 + (tick >> 1)) {
+	if (set_rtc_mmss(xtime.tv_sec) == 0)
 	    last_rtc_update = xtime.tv_sec;
-	  else
+	else
 	    last_rtc_update = xtime.tv_sec - 600; /* do it again in 60 s */
+    }
 }
 
 /* Converts Gregorian date to seconds since 1970-01-01 00:00:00.
@@ -130,11 +130,11 @@
 	unsigned int day, unsigned int hour,
 	unsigned int min, unsigned int sec)
 {
-	if (0 >= (int) (mon -= 2)) {	/* 1..12 -> 11,12,1..10 */
-		mon += 12;	/* Puts Feb last since it has leap day */
-		year -= 1;
-	}
-	return (((
+    if (0 >= (int) (mon -= 2)) {	/* 1..12 -> 11,12,1..10 */
+	mon += 12;	/* Puts Feb last since it has leap day */
+	year -= 1;
+    }
+    return (((
 	    (unsigned long)(year/4 - year/100 + year/400 + 367*mon/12 + day) +
 	      year*365 - 719499
 	    )*24 + hour /* now have hours */
@@ -144,30 +144,30 @@
 
 void time_init(void)
 {
-	unsigned int year, mon, day, hour, min, sec;
-	char buf[8];
-	extern int iic_control(unsigned char, int, char *, int);
-
-	iic_control(0xa0, 2, buf, 5);
-	sec = buf[0];
-	min = buf[1];
-	hour= buf[2];
-	day = buf[3] & 0x3f;
-	mon = buf[4] & 0x1f;
-	iic_control(0xa0, 0xc0, buf, 1);
-	year= buf[0];
-	BCD_TO_BIN(sec);
-	BCD_TO_BIN(min);
-	BCD_TO_BIN(hour);
-	BCD_TO_BIN(day);
-	BCD_TO_BIN(mon);
-
-	if ((year += 1900) < 1970)
-		year += 100;
-	xtime.tv_sec = mktime(year, mon, day, hour, min, sec);
-	xtime.tv_usec = 0;
+    unsigned int year, mon, day, hour, min, sec;
+    char buf[8];
+    extern int iic_control(unsigned char, int, char *, int);
+
+    iic_control(0xa0, 2, buf, 5);
+    sec = buf[0];
+    min = buf[1];
+    hour= buf[2];
+    day = buf[3] & 0x3f;
+    mon = buf[4] & 0x1f;
+    iic_control(0xa0, 0xc0, buf, 1);
+    year= buf[0];
+    BCD_TO_BIN(sec);
+    BCD_TO_BIN(min);
+    BCD_TO_BIN(hour);
+    BCD_TO_BIN(day);
+    BCD_TO_BIN(mon);
+
+    if ((year += 1900) < 1970)
+	year += 100;
+    xtime.tv_sec = mktime(year, mon, day, hour, min, sec);
+    xtime.tv_usec = 0;
 
-	if (request_irq(TIMER_IRQ, timer_interrupt, 0, "timer") != 0)
-		panic("Could not allocate timer IRQ!");
+    if (request_irq(IRQ_TIMER0, timer_interrupt, 0, "timer") != 0)
+	panic("Could not allocate timer IRQ!");
 }
 
diff -urN linux.store/linux/arch/arm/lib/Makefile linux/arch/arm/lib/Makefile
--- linux.store/linux/arch/arm/lib/Makefile	Sun Feb 11 09:32:40 1996
+++ linux/arch/arm/lib/Makefile	Tue Mar 12 13:36:52 1996
@@ -1,8 +1,22 @@
+#
+# linux/arch/arm/lib/Makefile
+#
+# Copyright (C) 1995, 1996 Russell King
+#
+
 O_TARGET := lib.o
 O_OBJS   := backtrace.o bitops.o delay.o irqs.o \
 	ll_char_wr.o io.o segment.o system.o traps.o ioc.o \
 	calls.o prints.o memfastset.o fp_support.o string.o \
 	floppydma.o
+
+ifdef CONFIG_BLK_DEV_FD1772
+O_OBJS += fd1772.o
+endif
+
+ifdef CONFIG_BLK_DEV_XD
+O_OBJS += mfm.o
+endif
 
 ifdef CONFIG_INET
 O_OBJS += iputils.o
diff -urN linux.store/linux/arch/arm/lib/fd1772.S linux/arch/arm/lib/fd1772.S
--- linux.store/linux/arch/arm/lib/fd1772.S	Thu Jan  1 01:00:00 1970
+++ linux/arch/arm/lib/fd1772.S	Mon Mar 11 23:02:11 1996
@@ -0,0 +1,98 @@
+@ Code for DMA with the 1772 fdc
+.text
+
+
+_fdc1772_fiqdata:
+@ Number of bytes left to DMA
+  .global _fdc1772_bytestogo
+_fdc1772_bytestogo:
+  .word 0
+@ Place to put/get data from in DMA
+  .global _fdc1772_dataaddr
+_fdc1772_dataaddr:
+  .word 0
+  
+  .global _fdc1772_fdc_int_done
+_fdc1772_fdc_int_done:
+  .word 0
+  .global _fdc1772_comendstatus
+_fdc1772_comendstatus:
+  .word 0
+
+@ We hang this off DMA channel 1
+    .global _fdc1772_comendhandler
+_fdc1772_comendhandler:
+  mov      r8,#0x3200000
+  ldrb     r9,[r8,#0x34]    @ IOC FIQ status
+  tst      r9,#2
+  subeqs   pc,r14,#4
+  mov      r9,#0x3200000
+  orr      r9,r9,#0x10000   @ FDC base
+  adr      r8,_fdc1772_fdc_int_done
+  ldrb     r10,[r9,#0]  @ FDC status
+  mov      r9,#1        @ Got a FIQ flag
+  stmia    r8,{r9,r10}
+  subs     pc,r14,#4
+
+
+    .global _fdc1772_dma_read
+_fdc1772_dma_read:
+  mov      r8,#0x3200000
+  ldrb     r9,[r8,#0x34]    @ IOC FIQ status
+  tst      r9,#1
+  beq      _fdc1772_dma_read_notours
+  orr      r8,r8,#0x10000   @ FDC base
+  ldrb     r10,[r8,#0xc]   @ Read from FDC data reg (also clears interrupt)
+  ldmia    r11,{r8,r9}
+  subs     r8,r8,#1        @ One less byte to go
+  @ If there was somewhere for this data to go then store it and update pointers
+  strplb   r10,[r9],#1     @ Store the data and increment the pointer
+  stmplia  r11,{r8,r9}     @ Update count/pointers
+  @ Handle any other interrupts if there are any
+_fdc1772_dma_read_notours:
+  @ Cant branch because this code has been copied down to the FIQ vector
+  ldr pc,[pc,#-4]
+  .word _fdc1772_comendhandler
+  .global _fdc1772_dma_read_end
+_fdc1772_dma_read_end:
+
+    .global _fdc1772_dma_write
+_fdc1772_dma_write:
+  mov      r8,#0x3200000
+  ldrb     r9,[r8,#0x34]    @ IOC FIQ status
+  tst      r9,#1
+  beq      _fdc1772_dma_write_notours
+  orr      r8,r8,#0x10000   @ FDC base
+  ldmia    r11,{r9,r10}
+  subs     r9,r9,#1        @ One less byte to go
+  @ If there really is some data then get it, store it and update count
+  ldrplb   r12,[r10],#1
+  strplb   r12,[r8,#0xc]   @ write it to FDC data reg
+  stmplia  r11,{r9,r10}    @ Update count and pointer - should clear interrupt
+  @ Handle any other interrupts
+_fdc1772_dma_write_notours:
+  @ Cant branch because this code has been copied down to the FIQ vector
+  ldr pc,[pc,#-4]
+  .word _fdc1772_comendhandler
+
+  .global _fdc1772_dma_write_end
+_fdc1772_dma_write_end:
+  
+
+@ Setup the FIQ R11 to point to the data and store the count, address
+@ for this dma
+@ R0=count
+@ R1=address
+  .global _fdc1772_setupdma
+_fdc1772_setupdma:
+	@ The big job is flipping in and out of FIQ mode
+	adr	r2,_fdc1772_fiqdata	@ This is what we really came here for
+  stmia  r2,{r0,r1}
+	mov	r3, pc
+	teqp	pc,#0x0c000001	@ Disable FIQs, IRQs and switch to FIQ mode
+	mov	r0,r0      	@ NOP
+	mov r11,r2
+	teqp	r3,#0		@ Normal mode
+	mov	r0,r0		@ NOP
+  mov pc,r14
+
diff -urN linux.store/linux/arch/arm/lib/floppydma.S linux/arch/arm/lib/floppydma.S
--- linux.store/linux/arch/arm/lib/floppydma.S	Sun Mar  3 13:11:49 1996
+++ linux/arch/arm/lib/floppydma.S	Tue Mar 12 13:40:31 1996
@@ -35,6 +35,7 @@
 @ r0 = length
 @ r1 = address
 @ r2 = floppy port
+@ Puts these into R9_fiq, R10_fiq, R11_fiq
 		.global	_floppy_fiqsetup
 _floppy_fiqsetup:
 		mov	ip, sp
diff -urN linux.store/linux/arch/arm/lib/io.S linux/arch/arm/lib/io.S
--- linux.store/linux/arch/arm/lib/io.S	Sun Mar  3 13:13:17 1996
+++ linux/arch/arm/lib/io.S	Fri Mar  8 22:27:50 1996
@@ -6,6 +6,7 @@
 
 #include <asm/assembler.h>
 		.text
+		.align
 
 #define OUT(reg)					\
 		mov	r8, reg, lsl \#16		;\
@@ -24,8 +25,6 @@
 @ purpose: read a byte from a hardware register.
 @ Proto  : unsigned char inb(int address);
 
-		.align
-
 		.global	___inb
 		.global	___inb_p
 		.global	___inbc
@@ -44,8 +43,6 @@
 @ purpose: read a short word from a hardware register.
 @ Proto  : unsigned char inw(int address);
 
-		.align
-
 		.global	___inw
 ___inw:		cmp	r0, #0x00c00000
 		movge	r2, #0
@@ -59,8 +56,6 @@
 @ Purpose: write a byte to a hardware register.
 @ Proto  : outb(unsigned char c,int address);
 
-		.align
-
 		.global	___outb
 		.global	___outb_p
 		.global	___outbc
@@ -79,8 +74,6 @@
 @ Purpose: write a short to a hardware register.
 @ Proto  : outw(unsigned short c,int address);
 
-		.align
-
 		.global	___outw
 ___outw:	cmp	r1, #0x00c00000
 		movge	r2, #0
@@ -95,8 +88,6 @@
 @ Proto  : inswb(int from_port, void *to, int len_in_bytes);
 @ Notes  : increment to
 
-		.align
-
 		.global	_insw
 		.global	_inswb
 _insw:		mov	r2, r2, lsl#1
@@ -175,8 +166,6 @@
 @ Proto  : outswb(int to_reg, void *from, int len_in_bytes);
 @ Notes  : increments from
 
-		.align
-
 		.global	_outsw
 		.global	_outswb
 _outsw:		mov	r2, r2, LSL#1
@@ -225,8 +214,6 @@
 @ Proto  : void vidc_write(int register, int value);
 @ Returns: nothing
 
-		.align
-
 		.global	_vidc_write
 _vidc_write:	bic	r1, r1, #0xFF000000
 		orr	r0, r1, r0, lsl #24
@@ -238,8 +225,6 @@
 @ Proto  : void memc_write(int register, int value);
 @ Returns: nothing
 
-		.align
-
 		.global	_memc_write
 _memc_write:	cmp	r0, #7
 		RETINSTR(movgt,pc,lr)
@@ -252,26 +237,26 @@
 		RETINSTR(mov,pc,lr)
 
 @ Purpose: call an expansion card loader to read bytes.
-@ Proto  : int read_loader(int offset, int card_base, int *loader);
+@ Proto  : char read_loader(int offset, char *card_base, char *loader);
 @ Returns: byte read
 
-		.align
-
-		.global	_read_loader
-_read_loader:	stmfd	sp!, {r4 - r12, lr}
+		.global	_ecard_loader_read
+_ecard_loader_read:
+		stmfd	sp!, {r4 - r12, lr}
 		mov	r11, r1
 		mov	r1, r0
 		mov	lr, pc
 		mov	pc, r2
 		LOADREGS(fd, sp!, {r4 - r12, pc})
 
-		.align
-msgg:
-		.ascii	"%08X  "
-		.align
+@ Purpose: call an expansion card loader to reset the card
+@ Proto  : void read_loader(int card_base, char *loader);
+@ Returns: byte read
 
-show:		stmfd	sp!, {r0-r12, lr}
-		mov	r1, r8
-		adr	r0, msgg
-		bl	_printk
-		LOADREGS(fd, sp!, {r0-r12, pc})
+		.global	_ecard_loader_reset
+_ecard_loader_reset:
+		stmfd	sp!, {r4 - r12, lr}
+		mov	r11, r0
+		mov	lr, pc
+		add	pc, r1, #8
+		LOADREGS(fd, sp!, {r4 - r12, pc})
diff -urN linux.store/linux/arch/arm/lib/ll_char_wr.S linux/arch/arm/lib/ll_char_wr.S
--- linux.store/linux/arch/arm/lib/ll_char_wr.S	Sun Mar  3 13:15:26 1996
+++ linux/arch/arm/lib/ll_char_wr.S	Sun Mar 10 16:31:30 1996
@@ -7,7 +7,7 @@
 #include <asm/assembler.h>
 		.text
 
-		.global	_ll_char_write
+		.global	_ll_write_char
 
 #define BOLD            0x01
 #define ITALIC          0x02
@@ -15,41 +15,44 @@
 #define FLASH           0x08
 #define INVERSE         0x10
 
-@ r4 = flags
-@ r3 = backc
-@ r2 = forec
-@ r1 = ch
-@ r0 = ps
-
 LC0:
 		.word	_bytes_per_char_h
 		.word	_video_num_columns
 		.word	_cmap_80
 
-_ll_char_write:
-		subs	r1, r1, #32
-		movlt	r1, #0
-		cmp	r1, #126-32
-		RETINSTR(movgt,pc,lr)
+_ll_write_char:
 		mov	ip, sp
 		stmfd	sp!, {r4 - r9, fp, ip, lr, pc}
 		sub	fp, ip, #4
-@ do inverse stuff
-		ldr	r4, [fp, #4]		@ get flags
-		eor	r4, r4, #UNDERLINE
-		tst	r4, #INVERSE
-		movne	r5, r3
-		movne	r3, r2
-		movne	r2, r5
-		tst	r4, #BOLD
+		eor	r4, r1, #UNDERLINE << 24
+/*
+ * calculate colours
+ */
+		tst	r1, #INVERSE << 24
+		moveq	r2, r1, lsr #8
+		moveq	r3, r1, lsr #16
+		movne	r2, r1, lsr #16
+		movne	r3, r1, lsr #8
+		tst	r1, #BOLD << 24
 		orrne	r2, r2, #8
-@ compute the offset required for each row
-		ldr	r5, [pc, #LC0 - . - 8]
-		ldrb	r5, [r5]
-		ldr	r6, [pc, #LC0 - . - 4]
-		ldrb	r6, [r6]
+		and	r3, r3, #255
+		and	r2, r2, #255
+/*
+ * calculate offset into character table
+ */
+		and	r1, r1, #255
+		subs	r1, r1, #32
+		movlt	r1, #0
+		cmp	r1, #126 - 32
+		movgt	r1, #0
+/*
+ * calculate offset required for each row
+ */
+		adr	r5, LC0
+		ldmia	r5, {r5, r6, r7}
+		ldr	r5, [r5]
+		ldr	r6, [r6]
 		mul	r6, r5, r6
-		ldr	r7, [pc, #LC0 - .]
 		mov	r1, r1, lsl #3
 		teq	r5, #8
 		beq	row8bpplp
@@ -57,7 +60,7 @@
 		ldrb	r9, [r7, r1]
 		and	r8, r1, #7
 		teq	r8, #7
-		tsteq	r4, #UNDERLINE
+		tsteq	r4, #UNDERLINE << 24
 		mvneq	r9, r9
 		sub	r8, r5, #1
 		mov	ip, #0
@@ -85,7 +88,7 @@
 		tst	r9, #1<<0
 		orreq	ip, ip, r3, lsl#28
 		orrne	ip, ip, r2, lsl#28
-		str	ip, [r0],r6
+		str	ip, [r0], r6
 		add	r1, r1,#1
 		tst	r1, #7
 		bne	row4bpplp
@@ -94,7 +97,7 @@
 row8bpplp:	ldrb	r9, [r7, r1]
 		and	r8, r1, #7
 		teq	r8, #7
-		tsteq	r4, #UNDERLINE
+		tsteq	r4, #UNDERLINE << 24
 		mvneq	r9, r9
 		tst	r9, #1<<7
 		moveq	r5, r3
diff -urN linux.store/linux/arch/arm/lib/mfm.S linux/arch/arm/lib/mfm.S
--- linux.store/linux/arch/arm/lib/mfm.S	Thu Jan  1 01:00:00 1970
+++ linux/arch/arm/lib/mfm.S	Mon Mar 11 23:02:11 1996
@@ -0,0 +1,118 @@
+@ Read/Write DMA code for the ST506/MFM hard drive controllers on the A400
+@   motherboard on ST506 podules.
+@ (c) David Alan Gilbert (gilbertd@cs.man.ac.uk) 1996
+
+#include <asm/assembler.h>
+ 
+_hdc63463_irqdata:
+@ Controller base address
+  .global _hdc63463_baseaddress
+_hdc63463_baseaddress:
+  .word 0
+
+  .global _hdc63463_irqpolladdress
+_hdc63463_irqpolladdress:
+  .word 0
+ 
+  .global _hdc63463_irqpollmask
+_hdc63463_irqpollmask:
+  .word 0
+
+@ where to read/write data  from the kernel data space
+  .global _hdc63463_dataptr
+_hdc63463_dataptr:
+  .word 0
+
+@ Number of bytes left to transfer
+  .global _hdc63463_dataleft
+_hdc63463_dataleft:
+  .word 0
+
+@ -------------------------------------------------------------------------
+@ hdc63463_writedma: DMA from host to controller
+@  internal reg usage: r0=hdc base address, r1=irq poll address, r2=poll mask
+@                      r3=data ptr, r4=data left, r5,r6=temporary
+  .global _hdc63463_writedma
+_hdc63463_writedma:
+  stmfd sp!,{r4-r9}
+  adr r5,_hdc63463_irqdata
+  ldmia r5,{r0,r1,r2,r3,r4}
+
+writedma_loop:
+  @ test number of remaining bytes to transfer
+  cmp r4,#0
+  beq writedma_end
+  bmi writedma_end
+
+  @ Check the hdc is interrupting
+  ldrb r5,[r1,#0]
+  tst r5,r2
+  beq writedma_end
+
+  @ Check the hdc is still busy and command has not ended and no errors
+  ldr r5,[r0,#32]     @ Status reg - 16 bit - its the top few bits which are status
+  tst r5,#0x3c00        @ Test for things which should be off
+  bne writedma_end
+  and r5,r5,#0x8000        @ This is test for things which should be on: Busy
+  cmp r5,#0x8000
+  bne writedma_end 
+
+  @ OK - pretty sure we should be doing this
+  @ Get two bytes - note it can be half word aligned; its easiest to read 2 bytes
+  ldrb r6,[r3],#1
+  ldrb r5,[r3],#1
+  orr  r6,r6,r5,lsl#8  @ Put them together, note big endian for HDC
+  orr  r6,r6,r6,lsl#16    @ Both halves of word for podule write
+  str  r6,[r0,#32+8]      @ Put the data out
+  subs r4,r4,#2        @ Decrement bytes to go
+  b writedma_loop
+
+writedma_end:
+  adr r5,_hdc63463_irqdata+12
+  stmia r5,{r3,r4}
+  ldmfd sp!,{r4-r9}
+  RETINSTR(mov,pc,lr)
+
+@ -------------------------------------------------------------------------
+@ hdc63463_readdma: DMA from controller to host
+@  internal reg usage: r0=hdc base address, r1=irq poll address, r2=poll mask
+@                      r3=data ptr, r4=data left, r5,r6=temporary
+  .global _hdc63463_readdma
+_hdc63463_readdma:
+  stmfd sp!,{r4-r9}
+  adr r5,_hdc63463_irqdata
+  ldmia r5,{r0,r1,r2,r3,r4}
+
+readdma_loop:
+  @ test number of remaining bytes to transfer
+  cmp r4,#0
+  beq readdma_end
+  bmi readdma_end
+
+  @ Check the hdc is interrupting
+  ldrb r5,[r1,#0]
+  tst r5,r2
+  beq readdma_end
+
+  @ Check the hdc is still busy and command has not ended and no errors
+  ldr r5,[r0,#32]     @ Status reg - 16 bit - its the top few bits which are status
+  tst r5,#0x3c00      @ Test for things which should be off
+  bne readdma_end
+  and r5,r5,#0x8000        @ This is test for things which should be on: Busy
+  cmp r5,#0x8000
+  bne readdma_end 
+
+  @ OK - pretty sure we should be doing this
+  @ Get two bytes - note it can be half word aligned; its easiest to read 2 bytes
+  ldr  r6,[r0,#8]     @ Read data from hdc - its in the bottom half
+  mov  r5,r6,lsr#8     @ Move second byte to bottom
+  strb r6,[r3],#1      @ Note endian swap in here
+  strb r5,[r3],#1
+  subs r4,r4,#2        @ Decrement bytes to go
+  b readdma_loop
+
+readdma_end:
+  adr r5,_hdc63463_irqdata+12
+  stmia r5,{r3,r4}
+  ldmfd sp!,{r4-r9}
+  RETINSTR(mov,pc,lr)
